import random,math
def array(N1, N2=0,N3=0):   #■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
NP        = 6     #都市の数
NUM       = 200   #染色体の数
USIZE     = NP*NP #染色体の長さ(都市の数^2)
Cross     = 0.4   #交叉率
Mutation  = 0.2   #突然変異率
Selection=1-(Cross+Mutation) #選択率
Prob      = array(3) #判定用累積度数分布
Prob[0]   = Selection
Prob[1]   = Prob[0]+Cross
Prob[2]   = 1
Data=array(2,NUM)
cityXY=[];distXY=array(NP,NP)
def setXY():
    global Data,USIZE
    XY=array(NP,2);kk=int(math.sqrt(NP)+0.000001)
    for i in range(NP):
        XY[i][0]= (i % kk)*20
        XY[i][1]= int(i/kk)*20
    return XY
            
def setDist():
    global cityXY,distXY;N=len(cityXY)
    distXY=array(N,N)
    for i in range(N):
        for j in range(N):
            if i !=j:
                DX=cityXY[i][0]-cityXY[j][0]
                DY=cityXY[i][1]-cityXY[j][1]
                distXY[i][j]=math.sqrt(DX*DX+DY*DY)
    return distXY
def genUnit(USIZE):#■複数の遺伝子生成
    global Data,NP,NUM; Unit=array(USIZE);
    for i in range(NP):
        k=int(random.random()*NP)
        j=i*NP+k;
        Unit[j]=1
    return Unit
def genData(cID,USIZE):#■複数の遺伝子生成
    global Data,cityXY,distXY; NUM=len(Data[0])
    for i in range(NUM):
        Data[cID][i]=genUnit(USIZE)
    cityXY=setXY()
    distXY=setDist()
def selfLoop(DT):#■自分自身に戻るかをチェック
    global NP
    for i in range(NP):#自分自身に戻るのはダメ
        if DT[i*NP+i]==1:return True
    return False
def onlyGoto(DT):#■行き先は一点のみかをチェック
    global NP
    for i in range(NP):#行き先は一点のみ
        jst=i*NP;N=0
        for j in range(NP):
            if DT[jst+j]==1:N+=1
            if N>1: return True
        if N==0: return True
    return False
def finalNoReturn(DT):#■最後先頭に戻るかのチェック
    global NP
    ii=0               
    for i in range(NP):
        jst=ii*NP;N=0
        for j in range(NP):
            if DT[jst+j]==1:ii=j;break
    if ii!=0:return True
    return False
def notAll(DT):#■全都市巡回していないかのチェック
    global NP;ch=array(NP)
    ii=0;ch[ii]=1           
    for i in range(NP):
        jst=ii*NP;N=0
        for j in range(NP):
            if DT[jst+j]==1:ii=j;ch[ii]=1;break
    for i in range(NP):
        if ch[i]==0: return True
    return False

def compDist(DT):#■距離の計算
    global cityXY,distXY, NP;N=len(cityXY)
    ii=0;T=0          
    for i in range(NP):
        jst=ii*NP;N=0
        for j in range(NP):
            if DT[jst+j]==1:
                T+=distXY[ii][j]
                ii=j;break
    return T
def elmFit(DT):#■適応度を求める(TSP問題)
    global NP
    if selfLoop(DT):return 1E-30
    if onlyGoto(DT):return 1E-30
    if finalNoReturn(DT):return 1E-30
    if notAll(DT):return 1E-30
    return 1/compDist(DT)
def setFitness(cID,USIZE):#■適応度計算
    global Data; NUM=len(Data[0])
    Fitness=array(NUM); V=USIZE/2
    for i in range(NUM):
        Fitness[i]=elmFit(Data[cID][i])
    return Fitness
def totalFitness(FitNess):#■全適応度合計
    NUM=len(FitNess); T=0
    for i in range(NUM):T+=FitNess[i]
    return T
def cumDisp(Fitness):#■適応度の累積分布生成
    NUM=len(Fitness)
    D=array(NUM);cD=array(NUM)
    T=totalFitness(Fitness)
    for i in range(NUM): D[i]=Fitness[i]/T
    cD[0]=D[0]
    for i in range(1,NUM): cD[i]=cD[i-1]+D[i]
    return cD
def selectUnit(CDisp):#■選択
    R=random.random();NUM=len(CDisp)
    for i in range(NUM):
        if R<CDisp[i]:return i
    return NUM-1
def twoPointProc(A,B,Debug=False):#■2点交差
    global USIZE,NP; AA=array(USIZE);BB=array(USIZE)
    S=int(random.random()*USIZE/NP)*NP
    E=S+NP-1
    for i in range(USIZE):
        if i>=S and i<=E: AA[i]=B[i];BB[i]=A[i]
        else:             AA[i]=A[i];BB[i]=B[i]
    return [AA,BB]
def uniformCross(A,B,Debug=False):#■一様交差
    global USIZE; AA=array(USIZE);BB=array(USIZE)
    for i in range(USIZE):
        if A[i]==B[i] or random.random()<0.5:
            AA[i]=A[i];BB[i]=B[i]
        else:AA[i]=B[i];BB[i]=A[i]
    return [AA,BB]
def crossProc(A,B,method=True,Debug=False):#■交叉処理選択
    if method:return twoPointProc(A,B,Debug)
    else:return uniformCross(A,B,Debug)
def mutationProc(A,Debug=False):#■突然変異
    global USIZE,NP;AA=array(USIZE)
    S=int(random.random()*USIZE/NP)*NP
    E=S+NP-1
    B=int(random.random()*NP)+S
    for i in range(USIZE):
        if   i>=S and i<=E:
            if i==B   : AA[i]=1
            else: AA[i]=0
        else :AA[i]=A[i]
    return AA
def printBit(k,DT,FT):#■ビット形式の生成
    S="%4d:"%k
    for i in range(len(DT)):
        if i%4==0: S+=" "
        S+="%1d" % DT[i]
    print(S+FT)
def printDT(cID):#■データ表示
    global Data,USIZE;
    Fitness=setFitness(cID,USIZE);NUM=len(Data[cID])
    for i in range(0,NUM):
        printBit(i,Data[cID][i],"%8.4f" % Fitness[i])
def copyList(A):
    N=len(A);R=array(N)
    for i in range(N): R[i]=A[i]
    return R
def printResult(cID,Debug=True):#■結果の表示
    global Data,USIZE;NUM=len(Data[cID])
    Fitness=setFitness(cID,USIZE);MX=Fitness[0]
    for i in range(1,NUM):
        if Fitness[i]>MX: MX=Fitness[i]
    LL=[]
    for i in range(0,NUM):
        if abs(Fitness[i]-MX)<0.001:
            LL=Data[cID][i]
            if Debug:printBit(i,Data[cID][i],"")
    return [MX,copyList(LL)]
def GA(NumG,Debug=False):#■GAメイン
    global Data
    cID=0;nID=1-cID; genData(nID,USIZE)
    NUM=len(Data[0])
    if Debug:
        print("\n初期値")
        printDT(nID)
        print("\n適応度の高い遺伝子")
        printResult(nID,Debug)
    for i in range(NumG):#ループ回数だけ繰返し
        cID=nID;nID=1-cID;
        Fitness=setFitness(cID,USIZE)#適応度を求める
        CDisp=cumDisp(Fitness)#適応度の累積度数
        k=0
        while k<NUM:#
            R=random.random()
            S1=selectUnit(CDisp)
            if R<Prob[0]:#選択
                Data[nID][k]=Data[cID][S1]
                k+=1
            elif R<Prob[1]:
                if k==NUM-1:#最後なら「選択」とみなす
                    Data[nID][k]=Data[cID][S1]
                    k+=1
                else:#交差(組み換え)
                    S2=selectUnit(CDisp)
                    AB=crossProc(Data[cID][S1],Data[cID][S2],True)
                    Data[nID][k]=AB[0]
                    k+=1
                    Data[nID][k]=AB[1]
                    k+=1
            else:#突然変異
                Data[nID][k]=mutationProc(Data[cID][S1])
                k+=1
    cID=nID
    if Debug:
        print("\n結果"); printDT(cID)
        print("\n適応度の高い遺伝子")
        
    R=printResult(cID,Debug)
    return R
def printRoot(DT):#■経路表示
    global NP;ch=array(NP)
    ii=0;ch[ii]=1;S="      P0"
    for i in range(NP):
        jst=ii*NP;N=0
        for j in range(NP):
            if DT[jst+j]==1:ii=j;ch[ii]=1;S+="→P%d"%ii;break
    print(S)
def printXY(cityXY):
    
    for i in range(len(cityXY)):
        print(i,"%8.4f, %8.4f"%(cityXY[i][0],cityXY[i][1]))

def loopGA(LOOP,ULOOP):
    global cityXY
    MX=-999;RX=[]
    for i in range(LOOP):
        R=GA(ULOOP)
        if i==0:
            printXY(cityXY);print()

        if R[0]==MX:
            flag=True
            for k in range(len(RX)):
                if RX[k]==R[1]:flag=False;break
            if flag: RX.append(R[1])
        elif R[0]>MX:MX=R[0];RX=[R[1]]
    print(MX)
    for i in range(len(RX)):
        printBit(i,RX[i],"")
        printRoot(RX[i])
loopGA(100,5)
#GA(10,True)
